#!/usr/bin/env python
# -*- Python -*-

from PyQt4 import QtCore, QtGui

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM_aist
import RTC

import codecs


OUT = [0, 0]



# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
GuiController_spec = ["implementation_id", "GuiController", 
		 "type_name",         "GuiController", 
		 "description",       "GuiController Component", 
		 "version",           "0.1", 
		 "vendor",            "Miyamoto Nobuhiko", 
		 "category",          "TEST", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

class GuiController(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
                
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_button = RTC.TimedLongSeq(RTC.Time(0,0),[])
		self._buttonOut = OpenRTM_aist.OutPort("button", self._d_button, OpenRTM_aist.RingBuffer(8))
		
		# Set OutPort buffers
		self.registerOutPort("button",self._buttonOut)



		

		

		

		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		

		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
            
		# Bind variables and configuration variable
		
		return RTC.RTC_OK


	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OKvdef onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onActivated(self, ec_id):
	#
        #       return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onExecute(self, ec_id):

            if(OUT[0] != 0 or OUT[1] != 0):
                self._d_button.data = OUT
                self._buttonOut.write()
                OUT[0] = 0
                OUT[1] = 0
            
            
            
	    return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	

class Dialog(QtGui.QDialog):
    def __init__(self, parent=None):
        super(Dialog, self).__init__(parent)
        
        self.mainLayout = QtGui.QVBoxLayout()
        self.button1 = QtGui.QPushButton("Button 1")
        self.mainLayout.addWidget(self.button1)
        self.button1.clicked.connect(self.OnButton1)
        self.button2 = QtGui.QPushButton("Button 2")
        self.mainLayout.addWidget(self.button2)
        self.button2.clicked.connect(self.OnButton2)

        self.setLayout(self.mainLayout)
        self.setWindowTitle("SAMPLE4")

        self.setMinimumSize(200, 200)

        

    def OnButton1(self):
        OUT[0] = 1

    def OnButton2(self):
        OUT[1] = 1

        



def MyModuleInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=GuiController_spec)
    manager.registerFactory(profile,
                            GuiController,
                            OpenRTM_aist.Delete)

    # Create a component
    comp = manager.createComponent("GuiController")



def main():
        app = QtGui.QApplication(sys.argv)
        dialog = Dialog()
	mgr = OpenRTM_aist.Manager.init(len(sys.argv), sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager(True)
	sys.exit(dialog.exec_())

if __name__ == "__main__":
	main()

